//
//  RootViewController.m
//  RSSLesson
//
//  Created by Jirka on 7.3.11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "RootViewController.h"
#import "RSSPRocessor.h"
#import "WebController.h"
#import "DetailViewController.h"

@implementation RootViewController

@synthesize items;

#pragma mark -
#pragma mark View lifecycle


- (void)viewDidLoad {
    
	items = nil;
	//RSSProcessor *rssProcessor = [[[RSSProcessor alloc] initWithDelegate:self] autorelease];
	//[rssProcessor parseRSSFeedAtUrl:@"http://www.zive.cz/system/RSS.xml"];
	
	RSSProcessor *rssProcessor = [[[RSSProcessor alloc] init] autorelease];
	[rssProcessor setDelegate:self];
	[rssProcessor parseRSSFeedAtUrl:@"http://www.zive.cz/system/RSS.xml"];	
	

//items = nil;
	//RSSProcessor *secondRssProcessor = [[[RSSProcessor alloc] initWithDelegate:self] autorelease];
	//[secondRssProcessor parseRSSFeedAtUrl:@"http://www.ceskenoviny.cz/sluzby/rss/index.php"];
	
	//http://servis.idnes.cz/rss.asp?c=zpravodaj

	[super viewDidLoad];
}


- (void) updateItemSource:(NSArray*)itemArray
{
	//NSMutableArray *tmpArray = [[[NSMutableArray alloc] init] autorelease];
	//[tmpArray addObjectsFromArray:[_delegate items]];
	//[tmpArray addObjectsFromArray:stories];
	
	//[_delegate setItems:tmpArray];
	//[[_delegate tableView] reloadData];
	[self setItems:itemArray];
}


/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */


#pragma mark -
#pragma mark Table view data source

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [items count];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
	// Configure the cell.
	[cell.textLabel setText:[[items objectAtIndex:indexPath.row] valueForKey:@"title"]];


    return cell;
}


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


#pragma mark -
#pragma mark Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
	DetailViewController *detailViewController = [[DetailViewController alloc] initWithNibName:@"DetailViewController" bundle:[NSBundle mainBundle]];
	[self.navigationController pushViewController:detailViewController animated:YES];

	//[detailViewController setUrl:[[items objectAtIndex:indexPath.row] valueForKey:@"link"]];
	NSString *l = [[items objectAtIndex:indexPath.row] valueForKey:@"link"];
	[detailViewController setUrl:l];
	
	//[[detailViewController titleLabel] setText:[[items objectAtIndex:indexPath.row] valueForKey:@"tittle"]];
	NSString *t = [[items objectAtIndex:indexPath.row] valueForKey:@"title"];
	[[detailViewController titleLabel] setText:t];
	
	//[[detailViewController textView] setText:[[items objectAtIndex:indexPath.row] valueForKey:@"summary"]];
	NSString *s = [[items objectAtIndex:indexPath.row] valueForKey:@"summary"];
	[[detailViewController textView] setText:s];
	
	
	//[[detailViewController timeLabel] setText:[[items objectAtIndex:indexPath.row] valueForKey:@"date"]];
	NSString *d = [[items objectAtIndex:indexPath.row] valueForKey:@"date"];
	[[detailViewController timeLabel] setText:d];
	

	
	[detailViewController release];
}


#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end

